Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions

# Material Class Reference

Defines the way an object appears in the presence of lighting. More...

Inheritance diagram for Material:

List of all members.

## Public Member Functions
| Material (Material const copy)
| Material (string name)
| Material ()
| clearAmbient ()
| Removes the explicit ambient color from the material.
| clearDiffuse ()
| Removes the explicit diffuse color from the material.
| clearEmission ()
| Removes the explicit emission color from the material.
| clearSpecular ()
| Removes the explicit specular color from the material.
int | compareTo (Material const other)
| Returns a number less than zero if this material sorts before the other one, greater than zero if it sorts after, or zero if they are equivalent.
VBase4 const | getAmbient ()
| Returns the ambient color setting, if it has been set.
VBase4 const | getDiffuse ()
| Returns the diffuse color setting, if it has been set.
VBase4 const | getEmission ()
| Returns the emission color setting, if it has been set.
bool | getLocal ()
| Returns the local viewer flag.
float | getShininess ()
| Returns the shininess exponent of the material.
VBase4 const | getSpecular ()
| Returns the specular color setting, if it has been set.
bool | getTwoside ()
| Returns the state of the two-sided lighting flag.
bool | hasAmbient ()
| Returns true if the ambient color has been explicitly set for this material, false otherwise.
bool | hasDiffuse ()
| Returns true if the diffuse color has been explicitly set for this material, false otherwise.
bool | hasEmission ()
| Returns true if the emission color has been explicitly set for this material, false otherwise.
bool | hasSpecular ()
| Returns true if the specular color has been explicitly set for this material, false otherwise.
bool | isAttribLocked ()
bool | operator!= (Material const other)
bool | operator< (Material const other)
Material | operator= (Material const copy)
bool | operator== (Material const other)
| output (ostream out)
| Outputs the Namable.
| setAmbient (VBase4 const color)
| Specifies the ambient color setting of the material.
| setAttribLock ()
| setDiffuse (VBase4 const color)
| Specifies the diffuse color setting of the material.
| setEmission (VBase4 const color)
| Specifies the emission color setting of the material.
| setLocal (bool local)
| Sets the local viewer flag.
| setShininess (float shininess)
| Sets the shininess exponent of the material.
| setSpecular (VBase4 const color)
| Specifies the diffuse color setting of the material.
| setTwoside (bool twoside)
| Set this true to enable two-sided lighting.
| write (ostream out, int indent)
## Static Public Member Functions
static TypeHandle | getClassType ()
static Material | getDefault ()
| Returns the default material.

## Detailed Description

Defines the way an object appears in the presence of lighting.

A material is only necessary if lighting is to be enabled; otherwise, the material isn't used.

## Constructor & Destructor Documentation

Material | ( | Material const | copy | ) |

Material | ( | string | name | ) |

Material | ( |  | ) |

## Member Function Documentation

clearAmbient | ( |  | ) |

Removes the explicit ambient color from the material.

clearDiffuse | ( |  | ) |

Removes the explicit diffuse color from the material.

clearEmission | ( |  | ) |

Removes the explicit emission color from the material.

clearSpecular | ( |  | ) |

Removes the explicit specular color from the material.

int compareTo | ( | Material const | other | ) |

Returns a number less than zero if this material sorts before the other one, greater than zero if it sorts after, or zero if they are equivalent.

The sorting order is arbitrary and largely meaningless, except to differentiate different materials.

VBase4 const getAmbient | ( |  | ) |

Returns the ambient color setting, if it has been set.

Returns (0,0,0,0) if the ambient color has not been set.

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented from Namable.

static Material getDefault | ( |  | ) | `[static]`

Returns the default material.

VBase4 const getDiffuse | ( |  | ) |

Returns the diffuse color setting, if it has been set.

Returns (1,1,1,1) if the diffuse color has not been set.

VBase4 const getEmission | ( |  | ) |

Returns the emission color setting, if it has been set.

Returns (0,0,0,0) if the emission color has not been set.

bool getLocal | ( |  | ) |

Returns the local viewer flag.

Set set_local().

float getShininess | ( |  | ) |

Returns the shininess exponent of the material.

VBase4 const getSpecular | ( |  | ) |

Returns the specular color setting, if it has been set.

Returns (0,0,0,0) if the specular color has not been set.

bool getTwoside | ( |  | ) |

Returns the state of the two-sided lighting flag.

See set_twoside().

bool hasAmbient | ( |  | ) |

Returns true if the ambient color has been explicitly set for this material, false otherwise.

bool hasDiffuse | ( |  | ) |

Returns true if the diffuse color has been explicitly set for this material, false otherwise.

bool hasEmission | ( |  | ) |

Returns true if the emission color has been explicitly set for this material, false otherwise.

bool hasSpecular | ( |  | ) |

Returns true if the specular color has been explicitly set for this material, false otherwise.

bool isAttribLocked | ( |  | ) |

bool operator!= | ( | Material const | other | ) |

bool operator< | ( | Material const | other | ) |

Material operator= | ( | Material const | copy | ) |

bool operator== | ( | Material const | other | ) |

output | ( | ostream | out | ) |

Outputs the Namable.

This function simply writes the name to the output stream; most Namable derivatives will probably redefine this.

Reimplemented from Namable.

setAmbient | ( | VBase4 const | color | ) |

Specifies the ambient color setting of the material.

This will be the multiplied by any ambient lights in effect on the material to set its base color.

This is the color of the object as it appears in the absence of direct light.

If this is not set, the object color will be used.

setAttribLock | ( |  | ) |

setDiffuse | ( | VBase4 const | color | ) |

Specifies the diffuse color setting of the material.

This will be multiplied by any lights in effect on the material to get the color in the parts of the object illuminated by the lights.

This is the primary color of an object; the color of the object as it appears in direct light, in the absence of highlights.

If this is not set, the object color will be used.

setEmission | ( | VBase4 const | color | ) |

Specifies the emission color setting of the material.

This is the color of the object as it appears in the absence of any light whatsover, including ambient light. It is as if the object is glowing by this color (although of course it will not illuminate neighboring objects).

If this is not set, the object will not glow by its own light and will only appear visible in the presence of one or more lights.

setLocal | ( | bool | local | ) |

Sets the local viewer flag.

Set this true to enable camera-relative specular highlights, or false to use orthogonal specular highlights. The default value is true. Applications that use orthogonal projection should specify false.

setShininess | ( | float | shininess | ) |

Sets the shininess exponent of the material.

This controls the size of the specular highlight spot. In general, larger number produce a smaller specular highlight, which makes the object appear shinier. Smaller numbers produce a larger highlight, which makes the object appear less shiny.

setSpecular | ( | VBase4 const | color | ) |

Specifies the diffuse color setting of the material.

This will be multiplied by any lights in effect on the material to compute the color of specular highlights on the object.

This is the highlight color of an object: the color of small highlight reflections.

If this is not set, highlights will not appear.

setTwoside | ( | bool | twoside | ) |

Set this true to enable two-sided lighting.

When two-sided lighting is on, both sides of a polygon will be lit by this material. The default is for two-sided lighting to be off, in which case only the front surface is lit.

write | ( | ostream | out,
|  | int | indent
| ) |  |

All Classes Namespaces Functions Variables Enumerations Enumerator Properties